#include <limits.h>
#include <stdbool.h>
#include "factor.h"

#define ADD(sum, val, overflow) \
   (UINT_MAX - (val) < (sum)? (*(overflow) = true, 0): ((sum) += (val)))

static unsigned int recursive_add_divisors(struct factors* f,
      unsigned int index, unsigned int div, bool* overflow) {
   if (index == f->nfactors) return 0; // all done
   unsigned int sum = recursive_add_divisors(f, index + 1, div, overflow);
   unsigned int d = div;
   for (unsigned int cnt = 1; cnt <= f->count[index]; ++cnt) {
      d *= f->factor[index];
      if (d == f->n) break;
      ADD(sum, d, overflow);
      unsigned int sum2 = recursive_add_divisors(f, index + 1, d, overflow);
      ADD(sum, sum2, overflow);
   }
   return sum;
}

unsigned int aliquot_sum(unsigned int n) {
   if (n <= 1) return 0;

   struct factors f;
   factor(n, &f);
   bool overflow = false;
   unsigned int sum = recursive_add_divisors(&f, 0, 1, &overflow);
   ADD(sum, 1, &overflow);
   if (overflow) return 0;
   return sum;
}
